<?php

namespace App\Http\Controllers;

use App\Jobs\newjobb;
use App\Product;
use App\ProductVariant;
use App\ProductImage;
use App\Setting;
use App\ProcessImport;
use App\Process_reimport;
use App\Jobs\newjob;
use Illuminate\Http\Request;
use Illuminate\Database\Eloquent\Collection;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\Translation\Tests\Dumper\IniFileDumperTest;
use Validator;
use File;
use Illuminate\Support\Facades\Log;
use Carbon\Carbon;
use Maatwebsite\Excel\Facades\Excel;

class ProductController extends Controller {

	public function __construct() {
        // Apply the jwt.auth middleware to all methods in this controller
        // except for the authenticate method. We don't want to prevent
        // the user from retrieving their token if they don't already have it
        $this->middleware('jwt.auth', ['except' => ['authenticate']]);
    }

    public function index() {		
		$per_page = \Request::get('per_page') ?: 20;
		$currUser = Auth::User();
		Log::info($currUser->id." -- started - ".date("Y-m-d H:i:s"));
		if($currUser->id == '1639' || $currUser->id == '18023'){// 
			$products = $currUser->products()->where('status', '!=', 'Imported')->orderBy('product_id', 'DESC');
			return $products->paginate($per_page);
		} else if($currUser->id == '10113'){
			$products = $currUser->products()->where('block', '=', 0)->where('status', '!=', 'Imported')->orderBy('product_id', 'DESC');
			return $products->paginate($per_page);
		} else if($currUser->id == '18328' || $currUser->id == '13382' || $currUser->id == '13138' || $currUser->id == '2481' || $currUser->id == '2279' ||  $currUser->id == '2904' || $currUser->id == '721'){
			$products = $currUser->products()->where('block', '=', 0)->orderBy('status', 'asc')->orderBy('product_id', 'desc');
			return $products->paginate($per_page);
		} else if($currUser->id == '3143' || $currUser->id == '16687'){
			$products = $currUser->products()->where('block', '=', 0)->orderBy('title', 'ASC');
			return $products->paginate($per_page);
		} else if($currUser->id == '6569'){
			$products = $currUser->products()->orderBy('title', 'ASC');
			return $products->paginate($per_page);
		} else if($currUser->id == '6412'){
			$products = $currUser->products()->orderBy('status', 'ASC');
			return $products->paginate($per_page);
		} else if($currUser->id == '4335'){
		    $orderbystr = "CAST(searchstring AS DECIMAL(10,2)) DESC";
			$products = $currUser->products()->orderByRaw($orderbystr);
			return $products->paginate($per_page);//
		} else if($currUser->id == '3720' ||    $currUser->id == '8079' || $currUser->id == '12655' || $currUser->id == '16804' || $currUser->id == '10503' || $currUser->id == '9784' || $currUser->id == '14739' || $currUser->id == '15000' || $currUser->id == '12592' || $currUser->id == '17346'  || $currUser->id == '44841' || $currUser->id == '44195' || $currUser->id == '46873' || $currUser->id =='48229' ||  $currUser->id == '46745'){//
			$products = $currUser->products()->where('deleted', '=', 0)->orderBy('product_id', 'DESC');
			return $products->paginate($per_page);
		} 
		 else if($currUser->id == '2564'){
			Log::info($currUser->id." -- index 2564 - ".date("Y-m-d H:i:s"));
		    $products = $currUser->products()->orderBy('ebayitemid', 'DESC');
			return $products->paginate($per_page);
		}
		 else if($currUser->id == '43764'){
			Log::info($currUser->id." -- index 2564 - ".date("Y-m-d H:i:s"));
		    $products = $currUser->products()->orderBy('ebayitemid', 'DESC');
			return $products->paginate($per_page);
		}

		else if ($currUser->id == '44719' || $currUser->id == '45738' || $currUser->id == '45165' || $currUser->id == '45631'){
			  
			$products = $currUser->products()->where('block','=','0')->where('deleted','=','0')->orderBy('ebayitemid', 'DESC');
			return $products->paginate($per_page);
		}

		// else if($currUser->id == '43975'){
			
		// 		$distinctProductIds = $currUser->variants()
		// 			->where('quantity', '>', 0)
		// 			->orderBy('product_id', 'DESC')
		// 			->distinct()
		// 			->pluck('product_id');
		// 		//	Log::info("hiiiiiiiiiii".$distinctProductIds);

		// 			//t the collection to an array
		// 	//$distinctProductIds11 =$distinctProductIds->toArray();
		// 		$products = $currUser->products()
		// 			->where('product_id', $distinctProductIds)
		// 			->orderBy('product_id', 'DESC')
		// 			->get(); // Use get() to retrieve the results
		// 			Log::info("hiiiiiiiiiii".$products);
		// 			return $products;

		// 		return $products->paginate($per_page);
		// 	//}
			

		// }
		else {
			//$products = $currUser->products()->with('variants')->with('variantsCount')->with('variants.mainImage')->orderBy('product_id', 'DESC');
			//$products = $currUser->products()->with('variants')->with('variantsCount')->orderBy('product_id', 'DESC')->paginate($per_page);
			$products = $currUser->products()->orderBy('product_id', 'DESC')->paginate($per_page);
			Log::info($currUser->id." -- Ended - ".date("Y-m-d H:i:s"));
			return $products;		
		}
	}

	public function search(Request $request) {
		$per_page = \Request::get('per_page') ?: 20;
		$currUser = Auth::User();
        ### search
		Log::info("searchternvvv".$request['query']);
        if ($request['query']) {
			 if($currUser->id == '41840' || $currUser->id == '46873'){
				$products = $currUser->products()->where('title','like','%'.$request['query'].'%')->orWhere('ebayitemid','like','%'.$request['query'].'%')->orderBy('product_id', 'DESC');
				return $products->paginate($per_page);	
			}
			
			else if($currUser->id == '4335'){
			    $orderbystr = "CAST(searchstring AS DECIMAL(10,2)) DESC";
				$products = $currUser->products()->where('title','like','%'.$request['query'].'%')->orderByRaw($orderbystr);
				return $products->paginate($per_page);	
			} 
			else if( $currUser->id == '44841'){
			    $products = $currUser->products()->where('title','like','%'.$request['query'].'%')->where('deleted', '=', 0)->orderBy('product_id', 'DESC');
				return $products->paginate($per_page);	
			}
			else if($currUser->id == '43975' ){
                   
				if($request['query'] == 'outofstock'){
					
					$products = $currUser->products()->where('searchstring','like','%'.$request['query'].'%')->orderBy('product_id', 'DESC');
				return $products->paginate($per_page);	

				  }
	         else {
				
			   $products = $currUser->products()->where('title','like','%'.$request['query'].'%')->orderBy('product_id', 'DESC');
				return $products->paginate($per_page);	

			 }
			}
			else if ($currUser->id == '44719' || $currUser->id == '45738' || $currUser->id == '45165'   || $currUser->id == '45631' || $currUser->id == '46873'){
			  
				
				Log::info("searchtern".$request['query']);
				$products = $currUser->products()->where('block','=','0')->where('deleted','=','0')->where('title','like','%'.$request['query'].'%')->orderBy('product_id', 'DESC');
				//Log::info("data".json_encode($products));

				return $products->paginate($per_page);
			}
			else {
				$products = $currUser->products()->where('title','like','%'.$request['query'].'%')->orWhere('ebayitemid','like','%'.$request['query'].'%')->orderBy('product_id', 'DESC');
				return $products->paginate($per_page);	
			}
        } else {
			Log::info("searchtern else ".$request['query']);
			return $this->index();
		}
    }
   
	public function block($id){
		$temp = explode(",", $id);
		$count = count($temp);
		if($count == 0){
			return response()->json(['error' => ["msg"=>["Please choose atleast one product."]]], 406);
		}
		$currUser = Auth::User();
		if($currUser->id != 5001){
    		$blockedCount = $currUser->products()->whereIn('product_id', $temp)->where(function ($query) {
    			$query->where('block', '=', 1)->orWhere('status', '!=', 'Ready to Import');
    				})->count();
    		if($blockedCount > 0){
    			$errMsg = "The selected products could not be blocked.";
    			if($count == 1){
    				$errMsg = "The selected product could not be blocked.";
    			}
    			return response()->json(['error' => ["msg"=>[$errMsg]]], 406);
    		}
		}
		$currUser->products()->whereIn('product_id', $temp)->update(['block' => 1]);
	//	$currUser->variants()->whereIn('product_id', $temp)->update(['block' => 1]);
        return response()->json(['success'], 200);
	}
	public function ShopifyToEbay()
	{
		$currUser = Auth::User();		
		//$currUser= User::where('id',1)->get();
		$ownername = $currUser->ownername;
		$email = $currUser->email;
		$shopurl = $currUser->shopurl;
		$token = $currUser->token;
		$created_at = $currUser->created_at;
		$updated_at = $currUser->updated_at;
		$EbKeys = $currUser->ebKey()->first();
		$sellerid = $EbKeys->sellerid;
		$Ebaytoken = $EbKeys->token;
		$siteid = $EbKeys->siteid;
		$Setting = $currUser->settings()->first();
		$shopifylocationid = $Setting->shopifylocationid;
		
		$data = [
			'ownername' => $ownername,
			'email' => $email,
			'shopurl' => $shopurl,
			'token' => $token,
			'created_at' => $created_at,
			'updated_at' => $updated_at,
			'sellerid' => $sellerid,
			'Ebaytoken' => $Ebaytoken,
			'siteid' => $siteid,
			'shopifylocationid' => $shopifylocationid,
		];
		
		// Convert the array to a JSON string
		$jsonData = json_encode($data);
		
		// Base64 encode the JSON string
		$base64Encoded = base64_encode($jsonData);
		
		// Output the result
		echo $base64Encoded;
	}
	public function unblock($id){
		$temp = explode(",", $id);
		$count = count($temp);
		if($count == 0){
			return response()->json(['error' => ["msg"=>["Please choose atleast one product."]]], 406);
		}
		$currUser = Auth::User();
		$currUser->products()->whereIn('product_id', $temp)->update(['block' => 0]);
	//	$currUser->variants()->whereIn('product_id', $temp)->update(['block' => 0]);
        return response()->json(['success'], 200);
	}

	public function push($id){
		if(!$this->validateMembership()){
			return response()->json(['error' => ["msg"=>["Your membership has been expired. Please activate the subscription to import more products."]]], 406);
		}
		$temp = explode(",", $id);
		$count = count($temp);
		$count2 = count($temp);
		if($count == 0){
			return response()->json(['error' => ["msg"=>["Please choose atleast one product."]]], 406);
		}
		$currUser = Auth::User();
		$user_id = $currUser->id;

		$count = $currUser->products()->whereIn('product_id', $temp)->where('status', '!=', 'Ready to Import')->count();

		if($count > 0){
			return response()->json(['error' => ["msg"=>['The selected products could not push to shopify because some items within the selection have already been imported.']]], 406);
		} else {
			$skulimit = $currUser->skulimit;
			$skuconsumed = $currUser->skuconsumed;
			$vproducts = $currUser->products()->whereIn('product_id', $temp)->where('block', 0)->where('duplicate', 0)->where('status', '=', 'Ready to Import');
			$vcount = $vproducts->count();			
			if($skulimit < ($skuconsumed + $vcount)){
				return response()->json(['error' => ["msg"=>['The number of eBay listings you want to import is more than your allowed limit. Please upgrade your plan.']]], 406);
			} else {
				$count1=$currUser->processimports()->where('user_id', $user_id)->first();
				$checkcount =0;
				if($count1){
					//Log::info("Count old count".json_encode($count1));
					 $totva =$count1->count;
					$countnew=$vcount+$totva;
					$checkcount = $countnew;
					Log::info("new count".$countnew);
					$currUser->processimports()->where('user_id', $user_id)->update(['count' => $countnew]);
					Log::info("new count has been updated".$countnew);
				}else{
					Log::info("Count old count 0");
					$import = new ProcessImport([
						'user_id' => $user_id,
						'count' => $count2, 
					]);
					$import->save();
					$checkcount = $count2;
					Log::info("new count have been added in processimport".$count2);
				
				}
				$currUser->products()->whereIn('product_id', $temp)->where('block', 0)->where('duplicate', 0)->where('status', '=', 'Ready to Import')->update(['status' => 'Import in Progress']);
				$currUser->skuconsumed = $skuconsumed + $vcount;
				$currUser->save();
				$msg="entered into new job in api";
				//newjobb::dispatch();
				$user =$user_id;
				// if($checkcount < 100){
				// dispatch(new newjobb($user));
		     	// }
				return response()->json(['skuconsumed' => $currUser->skuconsumed], 200);
			}
		}
	}

	public function pushall(){	
		if(!$this->validateMembership()){
			return response()->json(['error' => ["msg"=>["Your membership has been expired. Please activate the subscription to import more products."]]], 406);
		}
		$currUser = Auth::User();
		$skulimit = $currUser->skulimit;
		$skuconsumed = $currUser->skuconsumed;
		/*$products = $currUser->products()->where('status', 'Ready to Import')->where('block', 0)->with('variantsCount')->get();
		$vcount = 0;
		foreach($products as $product){			
			$vcount  = $vcount + $product->variantsCount()->first()->no_of_variants;
		}*/
		$vcountnew = $currUser->products()->where('block', 0)->where('duplicate', 0)->where('status', '=', 'Ready to Import');
		$vcount = $vcountnew->count();
		if($skulimit < ($skuconsumed + $vcount)){
			return response()->json(['error' => ["msg"=>['The number of ebay listings you want to import is more than your allowed limit. Please upgrade your plan.']]], 406);			
		} else {
               $count1  = $vcount;
			   $user_id = $currUser->id;
			   $count2=$currUser->processimports()->where('user_id', $user_id)->first();
			   
			if($count2){
				$count2vl =$count2->count;
				$countnew=$count1+$count2vl;
				$currUser->processimports()->where('user_id', $user_id)->update(['count' => $countnew]);
				Log::info("processbulk import cunt has been updated to ".$countnew);
			}else{
				//$count2vl = $count2['count'];
				$import = new ProcessImport([
					'user_id' => $user_id,
					'count' => $count1, 
				]);
				$import->save();
				Log::info("new count have been added in processimport".$count2->count);
			
			}

			$currUser->products()->where('status', 'Ready to Import')->where('block', 0)->where('duplicate', 0)->update(['status' => 'Import in Progress']);

			$currUser->skuconsumed = $skuconsumed + $vcount;
			$currUser->save();
			return response()->json(['skuconsumed' => $currUser->skuconsumed], 200);
		}		
	}
	
	public function getVariants(Request $request){
		$currUser = Auth::User();
		if($request->has("product_id")){
			$product_id = $request->input("product_id");
			$variants = $currUser->variants()->where('product_id', $product_id)->get();
			return $variants;
		} else {
			return array();
		}		
	}

	public function suggestedPlan(){
		$currUser = Auth::User();
		$count = $currUser->products()->count();//->where('quantity', '>', 0)
		$suggestedPlanType = 1;
		$suggestedPlanName = "BRONZE";
		if($count > 5000){
			$suggestedPlanType = 4;
			$suggestedPlanName = "CUSTOM";
		} else if($count > 2000){
			$suggestedPlanType = 3;
			$suggestedPlanName = "GOLD";
		} else if($count > 500) {
			$suggestedPlanType = 2;
			$suggestedPlanName = "SILVER";
		}		
		if($currUser->id == 721){
		    $suggestedPlanType = 3;
			$suggestedPlanName = "CUSTOM";
		}
		if($currUser->id == 212){
		    $suggestedPlanType = 3;
			$suggestedPlanName = "CUSTOM";
		}
		if($currUser->id == 1057){
		    $suggestedPlanType = 3;
			$suggestedPlanName = "CUSTOM";
		}
		if($currUser->id == 15864 || $currUser->id == 6232 || $currUser->id == 4059 || $currUser->id == 1358 || $currUser->id == 4946 || $currUser->id == 5587){
		    $suggestedPlanType = 1;
			$suggestedPlanName = "BRONZE";
		}
		if($currUser->id == 7205 || $currUser->id == 7370 || $currUser->id == 1250 || $currUser->id == 3766 || $currUser->id == 1886 || $currUser->id == 2487 || $currUser->id == 4350 || $currUser->id == 6168 || $currUser->id == 5715){
		    $suggestedPlanType = 3;
			$suggestedPlanName = "Gold";
		}
		if($currUser->id == 2221 || $currUser->id == 6232 || $currUser->id == 5461 || $currUser->id == 2275 || $currUser->id == 1748 || $currUser->id == 3463 || $currUser->id == 5852){
		    $suggestedPlanType = 1;
			$suggestedPlanName = "BRONZE";
		}
        if($currUser->id == 5053 || $currUser->id == 7683 || $currUser->id == 4884 || $currUser->id == 6236 || $currUser->id == 6317 || $currUser->id == 7103){
            $suggestedPlanType = 2;
            $suggestedPlanName = "SILVER";
        }
        if($currUser->id == 5891){
		    $suggestedPlanType = 2;
			$suggestedPlanName = "Silver";
		}
		return response()->json(['count' => $count, 'suggestedPlanType' => $suggestedPlanType, 'suggestedPlanName' => $suggestedPlanName], 200);
	}

	private function validateMembership(){
	    return true;
		/*$currUser = Auth::User();
		$review = $currUser->review;
		$paid_at = $currUser->paid_at;
		$created_at = $currUser->created_at;
		$fromtime = new Carbon($paid_at);
		if(strtotime($paid_at) < 1){
			$fromtime = new Carbon($created_at);
		}		
		$now = Carbon::now();
		$difference = $fromtime->diffInDays($now);
		if($difference > 30 && $currUser->sync == 0 && $currUser->review == 0) {
			return false;
		} else if($difference > 60 && $currUser->sync == 0 && $currUser->review == 1) {
			return false;
		} else {
			return true;
		}	*/	
	}
    
    public function exportFile(Request $request) {
		ini_set('memory_limit', '-1');
		$currUser = Auth::User();
		if($currUser->id != '10564'){
			return response()->json(['error' => ["msg" => ['You are not authorized to access this resource.']]], 406);
		}	
		$data = array();
		$data[] = array("Part Number", "Condition Description",	"Quantity",	"Unit of Measure", "Price",	"Shipping Cost", "Title", "Condition", "SKU", "Brand", "Item Description", "Images URL");
		$products = $currUser->products()->with('variants')->get();
		foreach($products as $product){
		    $partnumber = "";
		    $unitofmeasure = "";
		    $item_specific = $product->item_specific;
			$itemSpecArr = json_decode($item_specific, true);
			if(isset($itemSpecArr["Manufacturer Part Number"])){
			    $partnumber = $itemSpecArr["Manufacturer Part Number"];
			}
			$images = $product->variants[0]->images()->get(['imgurl']);
		    $row = array();
		    $row[0] = $partnumber;
		    $row[1] = $product->condition_note;
		    $row[2] = $product->variants[0]->quantity;
		    $row[3] = "";
		    $row[4] = $product->variants[0]->price;
		    $row[5] = "";
		    $row[6] = $product->title;
		    $row[7] = $product->condition_val;
		    $row[8] = $product->variants[0]->sku;
		    $row[9] = $product->brand;
		    $row[10] = "";
		    $row[11] = "";
		    $data[] = $row;
		}
		Excel::create('invreport', function($excel) use ($data) {
			$excel->sheet('Sheet 1', function ($sheet) use ($data) {
				$sheet->fromArray($data);
			});
		})->store("xlsx", public_path()."/reports/");
		return response()->json(['success'], 200);
    }
    
	public function updatePDesc(Request $request) {
		$currUser = Auth::User();
		$validator = Validator::make($request->all(), [
								'product_id' => 'required'
							]);
		if ($validator->fails()) {
			return response()->json(['error' => $validator->errors()], 406);
		} else {			
			$product_id = $request->input('product_id');
			$productObj = $currUser->products()->find($product_id);
			if($productObj){
				$productObj->update($request->all());
				return response()->json(['success'], 200);
			} else {
				return response()->json(['error' => ["msg"=> ['There was some error updating product description.']]], 406);
			}
		}
	}
	
	public function remove($ids){
		if(!$this->validateMembership()){
			return response()->json(['error' => ["msg"=>["Your membership has been expired. Please activate the subscription."]]], 406);
		}
		$temp = explode(",", $ids);
		$count = count($temp);
		if($count == 0){
			return response()->json(['error' => ["msg"=>["Please choose atleast one product."]]], 406);
		}
		$currUser = Auth::User();
		$token = $currUser->token;
		$shopurl = $currUser->shopurl;
		$user_id = $currUser->id;
		foreach($temp as $id){
			$productObj = $currUser->products()->find($id);
			if($productObj){
				$shopifyproductid = $productObj['shopifyproductid'];
				if(strlen($shopifyproductid) > 0){
					$this->deleteShopifyProduct($user_id, $token, $shopurl, $shopifyproductid);
				//	$productObj->variants()->update(['shopifyproductid' => '', 'shopifyvariantid' => '', 'status' => 'Ready to Import']);
					$productObj->shopifyproductid = '';
					$productObj->status = 'Ready to Import';
					$productObj->save();
				}
			}
		}
		return response()->json(['success'], 200);
	}

	public function reimport($id){
		if(!$this->validateMembership()){
			return response()->json(['error' => ["msg"=>["Your membership has been expired. Please activate the subscription to import more products."]]], 406);
		}
		$temp = explode(",", $id);
		$count = count($temp);
	
		$count2 = count($temp);
		if($count == 0){
			return response()->json(['error' => ["msg"=>["Please choose atleast one product."]]], 406);
		}
		$currUser = Auth::User();
		$user_id = $currUser->id;

		$count = $currUser->products()->whereIn('product_id', $temp)->where('status', '!=', 'Imported')->count();
		if($count > 0){
			return response()->json(['error' => ["msg"=>['The selected products could not be re-imported to shopify.']]], 406);
		} else {
		
			$count456=$currUser->process_reimport()->where('user_id', $user_id)->first();
			//Log::info("All from process reimport ".json_encode($count456));


			if($count456){
				$reval = $count456->count;
				$countnew12=$reval+$count2;
				Log::info("new reimport item count".$countnew12);
				$currUser->process_reimport()->where('user_id', $user_id)->update(['count' => $countnew12]);
				Log::info("processbulk reimport done ".$countnew12);
			}else{
				Log::info("entered in the else condition");

				$reimport = new Process_reimport([
					'user_id' => $user_id,
					'count' => $count2, 
					
		
				]);
				$reimport->save();
				Log::info("processbulk reimport done ".$count2);
			  }

			$currUser->products()->whereIn('product_id', $temp)->where('block', 0)->where('duplicate', 0)->where('status', '=', 'Imported')->update(['status' => 'reimport in progress']);
			return response()->json(['success'], 200);
		}
	}

	function deleteShopifyProduct($user_id, $token, $shopurl, $product_id){
		
	}
}
